
//   ***************************************************************************
//   **                                                                       **
//   **                          DEMO-Program                                 **
//   **                        for testing of a                               **
//   **                                                                       **
//   **                   Smart Card ToolSet PRO v3.3                         **
//   **                                                                       **
//   **                                                                       **
//   **              Copyright (c) 2005 by Igor V.Kharchenko                  **
//   **                                                                       **
//   ***************************************************************************

unit COM_Main_Scan;

interface

uses
  ComObj,
  StdVCL,
  AXCtrls,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, OleServer,
  SCardToolSet_COM_Server_TLB,
  ActnList;

Const
              tbl           = #9;
              dvd           = ' ... ';
              HexSymbols    = [' ','0'..'9','A'..'F','a'..'f'];

type

  TMainForm = class(TForm)
    ComboBox1: TComboBox;
    Label1: TLabel;
    PageControl1: TPageControl;
    Actions: TActionList;
    ConnectSCARD_act: TAction;
    DisconnectSCARD_act: TAction;
    Reopen_act: TAction;
    GetReadersList_act: TAction;
    OpenServer_act: TAction;
    CloseServer_act: TAction;
    TabSheet6: TTabSheet;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button8: TButton;
    Button6: TButton;
    SmartCardToolSet_COM_Server1: TSmartCardToolSet_COM_Server;
    Label2: TLabel;
    Panel1: TPanel;
    Memo: TMemo;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label20: TLabel;
    Button7: TButton;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Shape1: TShape;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Edit2: TEdit;
    Label6: TLabel;
    Edit3: TEdit;
    Label7: TLabel;
    Edit4: TEdit;
    Label8: TLabel;
    Edit5: TEdit;
    Label9: TLabel;
    Edit6: TEdit;
    Label10: TLabel;
    Edit7: TEdit;
    ClaFrom: TEdit;
    ClaTo: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Stop_act: TAction;
    Start_act: TAction;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SmartCardToolSet_COM_Server1BeforeDisconnectingSCARD(
      Sender: TObject);
    procedure SmartCardToolSet_COM_Server1BeforeReadersList(
      Sender: TObject);
    procedure SmartCardToolSet_COM_Server1DisconnectedSCARD(
      Sender: TObject);
    procedure SmartCardToolSet_COM_Server1_ServerApplicationClosed(
      Sender: TObject);
    procedure ConnectSCARD_actExecute(Sender: TObject);
    procedure DisconnectSCARD_actExecute(Sender: TObject);
    procedure Reopen_actExecute(Sender: TObject);
    procedure GetReadersList_actExecute(Sender: TObject);
    procedure OpenServer_actExecute(Sender: TObject);
    procedure CloseServer_actExecute(Sender: TObject);
    procedure CloseServer_actUpdate(Sender: TObject);
    procedure OpenServer_actUpdate(Sender: TObject);
    procedure ConnectSCARD_actUpdate(Sender: TObject);
    procedure DisconnectSCARD_actUpdate(Sender: TObject);
    procedure GetReadersList_actUpdate(Sender: TObject);
    procedure Reopen_actUpdate(Sender: TObject);
    procedure Stop_actExecute(Sender: TObject);
    procedure Start_actExecute(Sender: TObject);
    procedure Start_actUpdate(Sender: TObject);
    procedure Stop_actUpdate(Sender: TObject);
    procedure SmartCardToolSet_COM_Server1APDU(ASender: TObject;
      var ReaderName: WideString; var SW1, SW2: Byte; var SW_HEX,
      VerboseSWLookup: WideString);
    procedure SmartCardToolSet_COM_Server1BeforeAPDU(ASender: TObject;
      var ReaderName: WideString);
    procedure SmartCardToolSet_COM_Server1BeforeConnectingSCARD(
      Sender: TObject);
    procedure SmartCardToolSet_COM_Server1CardReady(ASender: TObject;
      var ReaderName, ATR, Protocol: WideString);
    procedure SmartCardToolSet_COM_Server1CardType(ASender: TObject;
      var ReaderName, ATR, Protocol, TypeName: WideString);
    procedure SmartCardToolSet_COM_Server1CardWait(ASender: TObject;
      var ReaderName: WideString);
    procedure SmartCardToolSet_COM_Server1ConnectedSCARD(Sender: TObject);
    procedure SmartCardToolSet_COM_Server1ReadersList(ASender: TObject;
      var ReadersNames: WideString);
    procedure SmartCardToolSet_COM_Server1_ERROR(ASender: TObject;
      var ErrorSource: WideString; var ErrorValue: Integer;
      var VerboseErrorLookup: WideString);
    procedure SmartCardToolSet_COM_Server1StateChanged(ASender: TObject;
      var ReaderName, StateHex, VerboseStateLookup: WideString;
      var StateValue: Integer);
    procedure SmartCardToolSet_COM_Server1CardDetected(ASender: TObject;
      var ReaderName: WideString);
  private
    { Private declarations }
  public
    { Public declarations }
    v        : variant;
    bStrings : TStringList;


    Opened     : boolean;
    Connected  : boolean;
    ScanInProcess : boolean;
    Aborted       : boolean;
    ErrorPresent  : boolean;

    procedure     StartScan;
    procedure     GrayScanControls(Disable:boolean);
    procedure     PrepareScanData;

    function      ClearHexLine(ss:string):string;

  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
try
bStrings := TStringList.Create;
Opened:=false;
Connected:=false;
PageControl1.ActivePageIndex:=0;
ScanInProcess:=false;
Aborted:=false;
ErrorPresent:=false;
finally
end;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
try
if bStrings<>nil then bStrings.Destroy;
finally
end;
end;




procedure TMainForm.SmartCardToolSet_COM_Server1BeforeDisconnectingSCARD(
  Sender: TObject);
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('---BeforeDisconnectingSCARD');
finally
end;
end;

procedure TMainForm.SmartCardToolSet_COM_Server1BeforeReadersList(
  Sender: TObject);
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('---BeforeReadersList');
finally
end;
end;



procedure TMainForm.SmartCardToolSet_COM_Server1DisconnectedSCARD(
  Sender: TObject);
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('DisconnectedSCARD');
Connected:=false;
ComboBox1.Clear;
finally
end;
end;


procedure TMainForm.SmartCardToolSet_COM_Server1_ServerApplicationClosed(
  Sender: TObject);
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('******** Server Closed!');
Memo.Lines.Add('');
  try
  SmartCardToolSet_COM_Server1.Disconnect;
  except  on em:exception do
          begin
          ShowMessage(em.message);
          end;
  end;
finally
Connected:=false;
Opened:=false;
end;
end;

procedure TMainForm.ConnectSCARD_actExecute(Sender: TObject);
begin
try
SmartCardToolSet_COM_Server1.ConnectSCARD;
finally
end;
end;

procedure TMainForm.DisconnectSCARD_actExecute(Sender: TObject);
begin
try
SmartCardToolSet_COM_Server1.DisconnectSCARD;
finally
end;
end;

procedure TMainForm.Reopen_actExecute(Sender: TObject);
var       ss:widestring;
begin
try
ss:=ComboBox1.Text;
SmartCardToolSet_COM_Server1.ReOpenReader(ss);
finally
end;end;

procedure TMainForm.GetReadersList_actExecute(Sender: TObject);
var       rl:widestring;
          rList:string;
          Ok:integer;
begin
try
ComboBox1.Clear;
SmartCardToolSet_COM_Server1.GetReadersList(rl,Ok);
if Ok=1
   then begin
        rList:=StringReplace(rl,'|',#13#10,[rfReplaceAll]);
        ComboBox1.Items.Text:=rList;
        ComboBox1.ItemIndex:=0;
        end;
finally
end;
end;

procedure TMainForm.OpenServer_actExecute(Sender: TObject);
var       ii,jj,vMajor,vMinor,vBuild:integer;
          ProgramTitle:widestring;
begin
try
  try
  SmartCardToolSet_COM_Server1.Connect;
  Opened:=true;
  Memo.Lines.Add('');
  Memo.Lines.Add('');
  Memo.Lines.Add('Server opened');
  Memo.Lines.Add('');
  SmartCardToolSet_COM_Server1.About(ProgramTitle,vMajor,vMinor,vBuild);
  Memo.Lines.Add(dvd+tbl+'Program Title   '+tbl+ProgramTitle);
  Memo.Lines.Add(dvd+tbl+'Major Version   '+tbl+IntToStr(vMajor));
  Memo.Lines.Add(dvd+tbl+'Minor Version   '+tbl+IntToStr(vMinor));
  Memo.Lines.Add(dvd+tbl+'Build           '+tbl+IntToStr(vBuild));
  Memo.Lines.Add('');

  SmartCardToolSet_COM_Server1.IsConnectedSCARD(ii);
  if ii<>0
     then begin
          GetReadersList_act.Execute;
          Memo.Lines.Add('Already connected to MS Smart Card service');
          Connected:=true;
          end
     else begin
          Memo.Lines.Add('Not connected to MS Smart Card service');
          Connected:=false;
          end;



  except  on em:exception do
          begin
          Opened:=false;
          end;
  end;
finally
end;
end;

procedure TMainForm.CloseServer_actExecute(Sender: TObject);
begin
try
  try
  ComboBox1.Clear;
  SmartCardToolSet_COM_Server1.Disconnect;
  Memo.Lines.Add('');
  Memo.Lines.Add('');
  Memo.Lines.Add('Server closed');
  except  on em:exception do
          begin
          end;
  end;
finally
Opened:=false;
Connected:=false;
end;
end;

procedure TMainForm.CloseServer_actUpdate(Sender: TObject);
begin
try
CloseServer_act.Enabled:=(Opened);
finally
end;
end;

procedure TMainForm.OpenServer_actUpdate(Sender: TObject);
begin
try
OpenServer_act.Enabled:=(not Opened);
finally
end;
end;

procedure TMainForm.ConnectSCARD_actUpdate(Sender: TObject);
begin
try
ConnectSCARD_act.Enabled:=(Opened) and (not Connected);
finally
end;
end;

procedure TMainForm.DisconnectSCARD_actUpdate(Sender: TObject);
begin
try
DisconnectSCARD_act.Enabled:=(Opened) and (Connected);
finally
end;
end;

procedure TMainForm.GetReadersList_actUpdate(Sender: TObject);
begin
try
GetReadersList_act.Enabled:=(Opened) and (Connected);
finally
end;
end;

procedure TMainForm.Reopen_actUpdate(Sender: TObject);
begin
try
Reopen_act.Enabled:=(Opened) and (Connected);
finally
end;
end;

procedure TMainForm.Stop_actExecute(Sender: TObject);
begin
try
Aborted:=true;
finally
end;
end;

procedure TMainForm.Start_actExecute(Sender: TObject);
begin
try
StartScan;
finally
end;
end;

procedure TMainForm.GrayScanControls(Disable: boolean);
begin
try
Edit1.Enabled:=(not Disable);
Edit2.Enabled:=(not Disable);
Edit3.Enabled:=(not Disable);
Edit4.Enabled:=(not Disable);
Edit5.Enabled:=(not Disable);
Edit6.Enabled:=(not Disable);
Edit7.Enabled:=(not Disable);
ClaFrom.Enabled:=(not Disable);
ClaTo.Enabled:=(not Disable);
finally
Application.ProcessMessages;
end;
end;

procedure TMainForm.PrepareScanData;
var       ii:integer;
begin

Edit7.Text:=ClearHexLine(Edit7.Text);
Edit1.Text:=ClearHexLine(Edit1.Text);

ClaFrom.Text:=ClearHexLine(ClaFrom.Text);
if ClaFrom.Text='' then ClaFrom.Text:='00';
ii:=StrToInt('$'+ClaFrom.Text);
ClaFrom.Text:=IntToHex(ii,2);

ClaTo.Text:=ClearHexLine(ClaTo.Text);
if ClaTo.Text='' then ClaTo.Text:='FF';
ii:=StrToInt('$'+ClaTo.Text);
ClaTo.Text:=IntToHex(ii,2);


Edit2.Text:=ClearHexLine(Edit2.Text);
if Edit2.Text>''
   then begin
        ii:=StrToInt('$'+Edit2.Text);
        Edit2.Text:=IntToHex(ii,2);
        end;
Edit3.Text:=ClearHexLine(Edit3.Text);
if Edit3.Text>''
   then begin
        ii:=StrToInt('$'+Edit3.Text);
        Edit3.Text:=IntToHex(ii,2);
        end;
Edit4.Text:=ClearHexLine(Edit4.Text);
if Edit4.Text>''
   then begin
        ii:=StrToInt('$'+Edit4.Text);
        Edit4.Text:=IntToHex(ii,2);
        end;
Edit5.Text:=ClearHexLine(Edit5.Text);
if Edit5.Text>''
   then begin
        ii:=StrToInt('$'+Edit5.Text);
        Edit5.Text:=IntToHex(ii,2);
        end;
Edit6.Text:=ClearHexLine(Edit6.Text);
if Edit6.Text>''
   then begin
        ii:=StrToInt('$'+Edit6.Text);
        Edit6.Text:=IntToHex(ii,2);
        end;


end;


function TMainForm.ClearHexLine(ss:string): string;
var      ll,ii:integer;
begin
try
result:='';
ll:=length(ss);
for ii:=1 to ll do
    begin
    if (ss[ii] in HexSymbols) then result:=result+ss[ii];
    end;

finally
end;
end;

procedure TMainForm.StartScan;
var       ii,cla_from,cla_to:integer;
          ReaderName: WideString;
          Cla: WideString;
          Ins: WideString;
          P1: WideString;
          P2: WideString;
          P3Lc: WideString;
          Le: WideString;
          DataIn,DataOut: WideString;
          SW1: Byte;
          SW2: Byte;
          SW_HEX: WideString;
          VerboseSWLookup: WideString;
          SW1SW2,SWLookup:string;
          Ok:integer;
          found:integer;
begin
try
found:=0;
Memo.Lines.Add('');
Memo.Lines.Add('=====  Scanning Begin');
ScanInProcess :=true;
Aborted       :=false;
ErrorPresent  :=false;

Start_act.Enabled:=false;
Stop_act.Enabled:=true;
GrayScanControls(ScanInProcess);

  try
  PrepareScanData;
  ReaderName:=ComboBox1.Text;

  cla_from:=StrToInt('$'+ClaFrom.Text);
  cla_to:=StrToInt('$'+ClaTo.Text);

  if cla_to<cla_from
     then raise exception.CreateFmt('ClassTo value can not be least than ClassFrom value!',[]);


  for ii:=cla_from to cla_to do
      begin
      Application.ProcessMessages;

      if Aborted
         then raise exception.CreateFmt('Scanning aborted by user!',[]);

      if ErrorPresent
         then break;



      Cla:=IntToHex(ii,2);
      Ins:=Edit2.Text;
      P1:=Edit3.Text;
      P2:=Edit4.Text;
      P3Lc:=Edit5.Text;
      Le:=Edit6.Text;
      DataIn:=Edit7.Text;
      SmartCardToolSet_COM_Server1.SendAPDU(ReaderName,cla,ins,p1,p2,p3lc,le,datain,DataOut,sw1,sw2,sw_hex,VerboseSWLookup,OK);

      if Ok=1
         then begin
              SW1SW2:=SW_HEX;
              SWLookup:=VerboseSWLookup;
              if pos(Edit1.Text,SW1SW2)=1
                 then begin
                      inc(found);
                      Memo.Lines.Add(dvd+tbl+'************************'+tbl+DataOut);
                      Memo.Lines.Add(dvd+tbl+'Success!'+tbl+DataOut);
                      Memo.Lines.Add(dvd+tbl+'Cla = '+cla+tbl+'SW1SW2 = '+SW1SW2+tbl+'"'+SWLookup+'"');
                      Memo.Lines.Add(dvd+tbl+'************************'+tbl+DataOut);
                      break;
                      end
                 else begin
                      Memo.Lines.Add(dvd+tbl+'Cla = '+cla+tbl+'SW1SW2 = '+SW1SW2+tbl+'"'+SWLookup+'"');
                      end;
              end;

      end;


  except  on em:exception do
          begin
          ShowMessage(em.message);
          end;
  end;

finally
ScanInProcess :=false;
Aborted       :=false;
Start_act.Enabled:=true;
Stop_act.Enabled:=false;
GrayScanControls(ScanInProcess);
Memo.Lines.Add('=====  Scanning end');
Memo.Lines.Add('=====  Found : '+IntToStr(found)+' APDU');
Memo.Lines.Add('');
end;
end;


procedure TMainForm.Start_actUpdate(Sender: TObject);
begin
try
Start_act.Enabled:=(Opened) and (Connected) and (not ScanInProcess);
finally
end;
end;

procedure TMainForm.Stop_actUpdate(Sender: TObject);
begin
try
Stop_act.Enabled:=(Opened) and (Connected) and (ScanInProcess);
finally
end;
end;

procedure TMainForm.SmartCardToolSet_COM_Server1APDU(ASender: TObject;
  var ReaderName: WideString; var SW1, SW2: Byte; var SW_HEX,
  VerboseSWLookup: WideString);
var   bSW1,bSW2:byte;
begin
try
if ScanInProcess then exit;
Memo.Lines.Add('');
Memo.Lines.Add('APDU          '+tbl+ReaderName);
bSW1:=SW1;
Memo.Lines.Add(dvd+tbl+'SW1        '+tbl+'0x'+IntToHex(bSW1,2));
bSW2:=SW2;
Memo.Lines.Add(dvd+tbl+'SW2        '+tbl+'0x'+IntToHex(bSW2,2));
Memo.Lines.Add(dvd+tbl+'SW_HEX     '+tbl+SW_HEX);
Memo.Lines.Add(dvd+tbl+'SWLookup   '+tbl+VerboseSWLookup);
finally
end;
end;

procedure TMainForm.SmartCardToolSet_COM_Server1BeforeAPDU(
  ASender: TObject; var ReaderName: WideString);
begin
try
if ScanInProcess then exit;
Memo.Lines.Add('');
Memo.Lines.Add('---BeforeAPDU'+tbl+ReaderName);
finally
end;
end;



procedure TMainForm.SmartCardToolSet_COM_Server1BeforeConnectingSCARD(
  Sender: TObject);
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('---BeforeConnectingSCARD');
finally
end;
end;

procedure TMainForm.SmartCardToolSet_COM_Server1CardReady(ASender: TObject;
  var ReaderName, ATR, Protocol: WideString);
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('CardReady     '+tbl+ReaderName);
Memo.Lines.Add(dvd+tbl+'ATR         '+tbl+ATR);
Memo.Lines.Add(dvd+tbl+'Protocol    '+tbl+Protocol);
finally
end;
end;

procedure TMainForm.SmartCardToolSet_COM_Server1CardType(ASender: TObject;
  var ReaderName, ATR, Protocol, TypeName: WideString);
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('CardType      '+tbl+ReaderName);
Memo.Lines.Add(dvd+tbl+'ATR         '+tbl+ATR);
Memo.Lines.Add(dvd+tbl+'Protocol    '+tbl+Protocol);
Memo.Lines.Add(dvd+tbl+'TypeName    '+tbl+TypeName);
finally
end;
end;

procedure TMainForm.SmartCardToolSet_COM_Server1CardWait(ASender: TObject;
  var ReaderName: WideString);
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('CardWait       '+tbl+ReaderName);
finally
end;
end;

procedure TMainForm.SmartCardToolSet_COM_Server1ConnectedSCARD(
  Sender: TObject);
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('ConnectedSCARD ');
Connected:=true;
finally
end;
end;

procedure TMainForm.SmartCardToolSet_COM_Server1ReadersList(
  ASender: TObject; var ReadersNames: WideString);
var       ss:string;
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('ReadersList    '+tbl+ReadersNames);
ss:=StringReplace(ReadersNames,'|',#13#10,[rfReplaceAll]);
ComboBox1.Items.Text:=ss;
ComboBox1.ItemIndex:=0;
finally
end;
end;

procedure TMainForm.SmartCardToolSet_COM_Server1_ERROR(ASender: TObject;
  var ErrorSource: WideString; var ErrorValue: Integer;
  var VerboseErrorLookup: WideString);
var   ii:integer;
begin
try
ii:=ErrorValue;
Memo.Lines.Add('');
Memo.Lines.Add('*** ERROR ************************');
Memo.Lines.Add(dvd+tbl+'ErrorSource'+tbl+ErrorSource);
Memo.Lines.Add(dvd+tbl+'ErrorValue'+tbl+'0x'+IntToHex(ii,8));
Memo.Lines.Add(dvd+tbl+'ErrorLookup'+tbl+VerboseErrorLookup);
ErrorPresent  := true;
finally
end;
end;

procedure TMainForm.SmartCardToolSet_COM_Server1StateChanged(
  ASender: TObject; var ReaderName, StateHex,
  VerboseStateLookup: WideString; var StateValue: Integer);
var           ii:integer;
begin
try
ii:=StateValue;
Memo.Lines.Add('');
Memo.Lines.Add('StateChanged: '+tbl+'0x'+IntToHex(ii,8));
Memo.Lines.Add(dvd+tbl+'ReaderName  '+tbl+ReaderName);
Memo.Lines.Add(dvd+tbl+'StateHex    '+tbl+StateHex);
Memo.Lines.Add(dvd+tbl+'StateLookup '+tbl+VerboseStateLookup);
finally
end;
end;

procedure TMainForm.SmartCardToolSet_COM_Server1CardDetected(
  ASender: TObject; var ReaderName: WideString);
begin
try
Memo.Lines.Add('');
Memo.Lines.Add('CardDetected   '+tbl+ReaderName);
finally
end;
end;

end.



